searchNodes=[{"doc":"Provide an Erlang friendly interface to Circuits Example Erlang code: circuits_i2c:open(&quot;i2c-1&quot;)","ref":":circuits_i2c.html","title":":circuits_i2c","type":"module"},{"doc":"See Circuits.I2C.close/1 .","ref":":circuits_i2c.html#close/1","title":":circuits_i2c.close/1","type":"function"},{"doc":"See Circuits.I2C.open/1 .","ref":":circuits_i2c.html#open/1","title":":circuits_i2c.open/1","type":"function"},{"doc":"See Circuits.I2C.read/3 .","ref":":circuits_i2c.html#read/3","title":":circuits_i2c.read/3","type":"function"},{"doc":"See Circuits.I2C.read/4 .","ref":":circuits_i2c.html#read/4","title":":circuits_i2c.read/4","type":"function"},{"doc":"See Circuits.I2C.write/3 .","ref":":circuits_i2c.html#write/3","title":":circuits_i2c.write/3","type":"function"},{"doc":"See Circuits.I2C.write/4 .","ref":":circuits_i2c.html#write/4","title":":circuits_i2c.write/4","type":"function"},{"doc":"See Circuits.I2C.write_read/4 .","ref":":circuits_i2c.html#write_read/4","title":":circuits_i2c.write_read/4","type":"function"},{"doc":"See Circuits.I2C.write_read/5 .","ref":":circuits_i2c.html#write_read/5","title":":circuits_i2c.write_read/5","type":"function"},{"doc":"Circuits.I2C lets you communicate with hardware devices using the I2C protocol.","ref":"Circuits.I2C.html","title":"Circuits.I2C","type":"module"},{"doc":"Return a list of available I2C bus names. If nothing is returned, it's possible that the kernel driver for that I2C bus is not enabled or the kernel's device tree is not configured. On Raspbian, run raspi-config and look in the advanced options. iex&gt; Circuits.I2C . bus_names ( ) [ &quot;i2c-1&quot; ]","ref":"Circuits.I2C.html#bus_names/0","title":"Circuits.I2C.bus_names/0","type":"function"},{"doc":"close the I2C bus","ref":"Circuits.I2C.html#close/1","title":"Circuits.I2C.close/1","type":"function"},{"doc":"Convenience method to scan all I2C buses for devices This is only intended to be called from the IEx prompt. Programs should use detect_devices/1 .","ref":"Circuits.I2C.html#detect_devices/0","title":"Circuits.I2C.detect_devices/0","type":"function"},{"doc":"Scan the I2C bus for devices by performing a read at each device address and returning a list of device addresses that respond. WARNING: This is intended to be a debugging aid. Reading bytes from devices can advance internal state machines and might cause them to get out of sync with other code. iex&gt; Circuits.I2C . detect_devices ( &quot;i2c-1&quot; ) [ 4 ] The return value is a list of device addresses that were detected on the specified I2C bus. If you get back 'Hh' or other letters, then IEx converted the list to an Erlang string. Run i v() to get information about the return value and look at the raw string representation for addresses. If you already have a reference to an open device, then you may pass its reference to detect_devices/1 instead.","ref":"Circuits.I2C.html#detect_devices/1","title":"Circuits.I2C.detect_devices/1","type":"function"},{"doc":"Return whether a device is present This function performs a simplistic check for an I2C device on the specified bus and address. It's not perfect, but works enough to be useful. Be warned that it does perform an I2C read on the specified address and this may cause some devices to actually do something.","ref":"Circuits.I2C.html#device_present?/2","title":"Circuits.I2C.device_present?/2","type":"function"},{"doc":"Scan all I2C buses for one or more devices This function takes a list of possible addresses and an optional detection function. It only scans addresses in the possible addresses list to avoid disturbing unrelated I2C devices. If a detection function is not passed in, a default one that performs a simple read and checks whether it succeeds is used. If the desired device has an ID register or other means of identification, the optional function should try to query that. If passing a custom function, be sure to return false rather than raise if there are errors. A list of bus name and address tuples is returned. The list may be empty. See also discover_one/2 .","ref":"Circuits.I2C.html#discover/2","title":"Circuits.I2C.discover/2","type":"function"},{"doc":"Same as discover_one/2 but raises on error","ref":"Circuits.I2C.html#discover_one!/2","title":"Circuits.I2C.discover_one!/2","type":"function"},{"doc":"Scans all I2C buses for one specific device This function and discover_one!/2 are convenience functions for the use case of helping a user find a specific device. They both call discover/2 with a list of possible I2C addresses and an optional function for checking whether the device is present. This function returns an :ok or :error tuple depending on whether one and only one device was found. See discover_one!/2 for the raising version.","ref":"Circuits.I2C.html#discover_one/2","title":"Circuits.I2C.discover_one/2","type":"function"},{"doc":"Return info about the low level I2C interface This may be helpful when debugging I2C issues.","ref":"Circuits.I2C.html#info/0","title":"Circuits.I2C.info/0","type":"function"},{"doc":"Open an I2C bus I2C bus names depend on the platform. Names are of the form &quot;i2c-n&quot; where the &quot;n&quot; is the bus number. The correct bus number can be found in the documentation for the device or on a schematic. Another option is to call Circuits.I2C.bus_names/0 to list them for you. I2c buses may be opened more than once. There is no need to share an I2C bus reference between modules. On success, this returns a reference to the I2C bus. Use the reference in subsequent calls to read and write I2C devices","ref":"Circuits.I2C.html#open/1","title":"Circuits.I2C.open/1","type":"function"},{"doc":"Initiate a read transaction and raise on error","ref":"Circuits.I2C.html#read!/4","title":"Circuits.I2C.read!/4","type":"function"},{"doc":"Initiate a read transaction to the I2C device at the specified address Options: :retries - number of retries before failing (defaults to no retries)","ref":"Circuits.I2C.html#read/4","title":"Circuits.I2C.read/4","type":"function"},{"doc":"Write data to the I2C device at address and raise on error Options: :retries - number of retries before failing (defaults to no retries)","ref":"Circuits.I2C.html#write!/4","title":"Circuits.I2C.write!/4","type":"function"},{"doc":"Write data to the I2C device at address . Options: :retries - number of retries before failing (defaults to no retries)","ref":"Circuits.I2C.html#write/4","title":"Circuits.I2C.write/4","type":"function"},{"doc":"Write data to an I2C device and then immediately issue a read. Raise on errors. Options: :retries - number of retries before failing (defaults to no retries)","ref":"Circuits.I2C.html#write_read!/5","title":"Circuits.I2C.write_read!/5","type":"function"},{"doc":"Write data to an I2C device and then immediately issue a read. This function is useful for devices that want you to write the &quot;register&quot; location to them first and then issue a read to get its contents. Many devices operate this way and this function will issue the commands back-to-back on the I2C bus. Some I2C devices actually require that the read immediately follows the write. If the target supports this, the I2C transaction will be issued that way. On the Raspberry Pi, this can be enabled globally with File.write!(&quot;/sys/module/i2c_bcm2708/parameters/combined&quot;, &quot;1&quot;) Options: :retries - number of retries before failing (defaults to no retries)","ref":"Circuits.I2C.html#write_read/5","title":"Circuits.I2C.write_read/5","type":"function"},{"doc":"I2C device address This is a &quot;7-bit&quot; address for the device. Some devices specify an &quot;8-bit&quot; address in their documentation. You can tell if you have an &quot;8-bit&quot; address if it's greater than 127 (0x7f) or if the documentation talks about different read and write addresses. If you have an 8-bit address, divide it by 2.","ref":"Circuits.I2C.html#t:address/0","title":"Circuits.I2C.address/0","type":"type"},{"doc":"I2C bus Call open/1 to obtain an I2C bus reference and then pass it to the read and write functions for interacting with devices.","ref":"Circuits.I2C.html#t:bus/0","title":"Circuits.I2C.bus/0","type":"type"},{"doc":"","ref":"Circuits.I2C.html#t:opt/0","title":"Circuits.I2C.opt/0","type":"type"},{"doc":"Function to report back whether a device is present See discover/2 for how a custom function can improve device detection when the type of device being looked for is known.","ref":"Circuits.I2C.html#t:present?/0","title":"Circuits.I2C.present?/0","type":"type"},{"doc":"Circuits.I2C lets you communicate with hardware devices using the I2C protocol. If you're coming from Elixir/ALE, check out our porting guide .","ref":"readme.html","title":"Elixir Circuits - I2C","type":"extras"},{"doc":"If you're using Nerves or compiling on a Raspberry Pi or other device with I2C support, then add circuits_i2c like any other Elixir library: def deps do [ { :circuits_i2c , &quot;~&gt; 1.0&quot; } ] end Circuits.I2C doesn't load device drivers, so you may need to load them beforehand. If you are using Nerves on a supported platform, this is enabled for you already. If using Raspbian, the Adafruit Raspberry Pi I2C instructions may be helpful. Internally, it uses the Linux &quot;i2cdev&quot; interface so that it does not require board-dependent code.","ref":"readme.html#getting-started","title":"Elixir Circuits - I2C - Getting started","type":"extras"},{"doc":"An Inter-Integrated Circuit (I2C) bus supports addressing hardware components and bidirectional use of the data line. The following shows a bus IO expander connected via I2C to the processor. The protocol for talking to the IO expander is described in the MCP23008 Datasheet . Here's a simple example of using it. # On the Raspberry Pi, the IO expander is connected to I2C bus 1 (i2c-1). # Its 7-bit address is 0x20. (see datasheet) iex&gt; alias Circuits.I2C Circuits.I2C iex&gt; { :ok , ref } = I2C . open ( &quot;i2c-1&quot; ) { :ok , # Reference &lt; ... &gt; } # By default, all 8 GPIOs are set to inputs. Set the 4 high bits to outputs # so that we can toggle the LEDs. (Write 0x0f to register 0x00) iex&gt; I2C . write ( ref , 0x20 , &lt;&lt; 0x00 , 0x0f &gt;&gt; ) :ok # Turn on the LED attached to bit 4 on the expander. (Write 0x10 to register # 0x09) iex&gt; I2C . write ( ref , 0x20 , &lt;&lt; 0x09 , 0x10 &gt;&gt; ) :ok # Read all 11 of the expander&#39;s registers to see that the bit 0 switch is # the only one on and that the bit 4 LED is on. iex&gt; I2C . write ( ref , 0x20 , &lt;&lt; 0 &gt;&gt; ) # Set the next register to be read to 0 :ok iex&gt; I2C . read ( ref , 0x20 , 11 ) { :ok , &lt;&lt; 15 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 17 , 16 &gt;&gt; } # The operation of writing one or more bytes to select a register and # then reading is very common, so a shortcut is to just run the following: iex&gt; I2C . write_read ( ref , 0x20 , &lt;&lt; 0 &gt;&gt; , 11 ) { :ok , &lt;&lt; 15 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 17 , 16 &gt;&gt; } # The 17 in register 9 says that bits 0 and bit 4 are high # We could have just read register 9. iex&gt; I2C . write_read ( ref , 0x20 , &lt;&lt; 9 &gt;&gt; , 1 ) { :ok , &lt;&lt; 17 &gt;&gt; }","ref":"readme.html#i2c","title":"Elixir Circuits - I2C - I2C","type":"extras"},{"doc":"How do I debug? The most common issue is communicating with an I2C for the first time. For I2C, first check that an I2C bus is available: iex&gt; Circuits.I2C . bus_names [ &quot;i2c-1&quot; ] If the list is empty, then I2C is either not available, not enabled, or not configured in the kernel. If you're using Raspbian, run raspi-config and check that I2C is enabled in the advanced options. If you're on a BeagleBone, try running config-pin and see the Universal I/O project to enable the I2C pins. On other ARM boards, double check that I2C is enabled in the kernel and that the device tree configures it. Once an I2C bus is available, try detecting devices on it: iex&gt; Circuits.I2C . detect_devices ( ) Circuits.I2C . detect_devices Devices on I2C bus &quot;i2c-1&quot; : * 64 ( 0x40 ) * 112 ( 0x70 ) 2 devices detected on 1 I2C buses The return value here is a list of device addresses that were detected. It is still possible that the device will work even if it does not detect, but you probably want to check wires at this point. If you have a logic analyzer, use it to verify that I2C transactions are being initiated on the bus. I2C seems slow. What could be wrong? I2C buses are usually run at 100 kbit/s or 400 kbit/s. Many devices support higher speeds. The tradeoff is that higher speeds are sometimes don't work as well especially if you're using jumper cables to connect parts together. The Raspberry Pi runs the I2C bus at a low speed - probably for this reason. Other things to check: Can you reduce the reads and writes? I2C devices let you read or write many bytes at the same time. Each transaction has overhead so minimizing transaction helps. Can you reduce the total number of bytes in each transaction? For example, do you need to read a particular register? Is there a mode that the device can be put it so that it only returns useful data? Can a write and read be combined? The Circuits.I2C.write_read function is more efficent than a separate write followed by a read. Does the device support a queue mode? Some devices have internal queues that allow the host to copy out more than one sample each time. Where can I get help? The hardest part is communicating with a device for the first time. The issue is usually unrelated to Circuits.I2C . If you expand your searches to include Python and C forums, you'll frequently find the answer. If that fails, try posting a question to the Elixir Forum . Tag the question with Nerves and it will have a good chance of getting to the right people. Feel free to do this even if you're not using Nerves. Can I develop code that uses Circuits.I2C on my laptop? You'll need to fake out the hardware. Code to do this depends on what your hardware actually does, but here's one example: Compiling and testing Elixir Nerves on your host machine Please share other examples if you have them. Will it run on Arduino? No. This only runs on Linux-based boards. If you're interested in controlling an Arduino from a computer that can run Elixir, check out nerves_uart for communicating via the Arduino's serial connection or firmata for communication using the Arduino's Firmata protocol. How do I call Circuits.I2C from Erlang? An Erlang-friendly binding has been provided to simplify syntax when calling Circuits.I2C functions from Erlang code. Instead of prefixing calls with 'Elixir.Circuits.I2C': use the binding circuits_i2c: . For example: circuits_i2c:open(&quot;i2c-1&quot;) .","ref":"readme.html#faq","title":"Elixir Circuits - I2C - FAQ","type":"extras"},{"doc":"Code from the library is licensed under the Apache License, Version 2.0.","ref":"readme.html#license","title":"Elixir Circuits - I2C - License","type":"extras"},{"doc":"The Circuits.I2C package is the next version of Elixir/ALE's I2C support. If you're currently using Elixir/ALE, you're encouraged to switch. Here are some benefits: Supported by both the maintainer of Elixir/ALE and a couple others. They'd prefer to support Circuits.I2C issues. Much faster than Elixir/ALE. Simplified API Circuits.I2C uses Erlang's NIF interface. NIFs have the downside of being able to crash the Erlang VM. Experience with Elixir/ALE has given many of us confidence that this won't be a problem.","ref":"porting.html","title":"Porting Elixir/ALE to Circuits.I2C","type":"extras"},{"doc":"Circuits.I2C is not a GenServer , so if you've added ElixirALE.I2C to a supervision tree, you'll have to take it out and manually call Circuits.I2C.open to obtain a reference. A common pattern is to create a GenServer that is descriptive of what the I2C device does and have it be responsible for all I2C calls. The remain modifications should mostly be mechanical: Rename references to ElixirALE.I2C to Circuits.I2C and elixir_ale to circuits_i2c Change calls to ElixirALE.I2C.start_link/2 to Circuits.I2C.open/1 . You'll need to remove the I2C address from the call to open. While you're at it, review the arguments to open to not include any GenServer options. Add the I2C device's bus address to all of the read , write , and write_read calls. We recommend making a short helper function that has the I2C address. The read and write_read functions now return {:ok, result} tuples on success so add code to handle that. Alternately, call read! or write_read! and they will raise an exception if there's an error. Look for calls to I2C.read_device , I2C.write_device and I2C.write_read_device and remove the _device part. Consider adding a call to Circuits.I2C.close/1 if there's an obvious place to release the I2C. This is not strictly necessary since the garbage collector will free unreferenced I2C references. If you manually implemented I2C bus retry logic, consider specifying the :retries option to have Circuits.I2C retry for you. Change calls to ElixirALE.I2C.device_names/0 to Circuits.I2C.bus_names/0 . If you find that you have to make any other changes, please let us know via an issue or PR so that other users can benefit.","ref":"porting.html#code-modifications","title":"Porting Elixir/ALE to Circuits.I2C - Code modifications","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Fixes Properly mark I/O bound functions in NIF.","ref":"changelog.html#v1-0-1-12-28-2021","title":"Changelog - v1.0.1 - 12-28-2021","type":"extras"},{"doc":"This release only changes the version number. No code has changed.","ref":"changelog.html#v1-0-0-10-20-2021","title":"Changelog - v1.0.0 - 10-20-2021","type":"extras"},{"doc":"This release only has doc and build output cleanup. No code has changed.","ref":"changelog.html#v0-3-9","title":"Changelog - v0.3.9","type":"extras"},{"doc":"New features Add Circuits.I2C.discover/2 and Circuits.I2C.discover_one/2 . These functions are intended for library authors wanting to provide good suggestions or defaults to their users. See the hex docs for more information. Thanks to Bruce Tate for the idea and PR. Improvements The stub I2C implementation is now used whenever MIX_ENV=test . While this is not generally useful for testing code that uses Circuits.I2C, it does prevent accidental use of real I2C buses in unit tests on those systems with real I2C buses.","ref":"changelog.html#v0-3-8","title":"Changelog - v0.3.8","type":"extras"},{"doc":"Improvements Add I2C address in hex showing detected devices","ref":"changelog.html#v0-3-7","title":"Changelog - v0.3.7","type":"extras"},{"doc":"Bug fixes Add -fPIC to compilation flags to fix build with nerves_system_x86_64 and other environments using the Musl C toolchains","ref":"changelog.html#v0-3-6","title":"Changelog - v0.3.6","type":"extras"},{"doc":"Bug fixes Reduce the number of I2C addresses scanned for detection to avoid confusing some devices.","ref":"changelog.html#v0-3-5","title":"Changelog - v0.3.5","type":"extras"},{"doc":"This release should work on Erlang/OTP 20 - 22 and Elixir 1.4 and newer. The CI process has been updated to verify more versions now. Bug fixes Improve error message when bus doesn't exist","ref":"changelog.html#v0-3-4","title":"Changelog - v0.3.4","type":"extras"},{"doc":"Bug fixes Fix binary handling in NIF. This fixes segfaults and other errors when run on Raspbian.","ref":"changelog.html#v0-3-3","title":"Changelog - v0.3.3","type":"extras"},{"doc":"Bug fixes Fix file handle leak when I2C bus references were garbage collected.","ref":"changelog.html#v0-3-2","title":"Changelog - v0.3.2","type":"extras"},{"doc":"Bug fixes Build C source under the _build directory so that changing targets properly rebuilds the C code as well as the Elixir code.","ref":"changelog.html#v0-3-1","title":"Changelog - v0.3.1","type":"extras"},{"doc":"Print detected devices instead of an error.","ref":"changelog.html#v0-3-0","title":"Changelog - v0.3.0","type":"extras"},{"doc":"Minor text updates. Remove i2c_ from i2c_address and i2c_bus.","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"Initial release to hex.","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]